#!/usr/bin/python
## -*- utf-8 -*-

import logging
log = logging.getLogger(__name__) 

import communication
import game
import hildon
import gtk
import threading
from util import *
import pygtk
import select
import media
import sys


##############################################################################
##

class plusOneApp(hildon.Program):
  def __init__(self):
    hildon.Program.__init__(self)
    
  def initWindow(self):
    
    self.score = 0
    self.correct_pattern = 0  
    self.visualAid = 0
    self.firstRun = 1
    
    self.window = hildon.Window()
    self.window.connect("delete_event", self.quit)  
    self.window.fullscreen()
    self.add_window(self.window)
    self.soundObject = media.PlaySound()
    self.imageHandler = media.ImageHandler()
    
    #table = gtk.Table(8,4,True)
            
    table = gtk.Table(80,48,True)
    self.label = gtk.Label(" ")
    self.scoreTitle = gtk.Label("PLAYER SCORE")
    self.scoreLabel = gtk.Label(str(self.score))
    
    self.turnText = gtk.Label("GAME INITIALIZING")
    self.turnCount = gtk.Label("TURN: 0+1")
    
    self.width = 100
    self.guitarButton = gtk.Button()
    #self.guitarButton.connect("released", self.playClick,("Guitar"))
    self.guitarButton.connect("pressed", self.playClick,("Guitar"))
    self.guitarButton.set_focus_on_click(False)
    
    self.drumButton = gtk.Button()
    self.drumButton.connect("pressed", self.playClick,("Drum"))
    self.drumButton.set_focus_on_click(False)
  
    self.pianoButton = gtk.Button()
    self.pianoButton.connect("pressed", self.playClick,("Piano"))
    self.pianoButton.set_focus_on_click(False)
  
    self.trumpetButton = gtk.Button()
    self.trumpetButton.connect("pressed", self.playClick,("Trumpet"))
    self.trumpetButton.set_focus_on_click(False)
  
    self.violinButton = gtk.Button()
    self.violinButton.connect("pressed", self.playClick,("Violin"))
    self.violinButton.set_focus_on_click(False)
    
    self.resetButton = gtk.Button("Reset")
    self.resetButton.connect("clicked",self.on_reset) 
    
    self.quitButton = gtk.Button("Quit")
    self.quitButton.connect("clicked",self.on_quit) 
    
    self.helpButton = gtk.Button("Help")
    self.helpButton.connect("clicked",self.on_help) 
    
    self.initButtonImages("normal", self.width)
  
        
    #table.attach(button,6,7,3,4)
    #table.attach(label,3,4,1,2)
    table.attach(self.guitarButton,5,17,50,77)
    table.attach(self.drumButton,20,32,50,77)
    table.attach(self.pianoButton,35,47,50,77)
    table.attach(self.trumpetButton,50,62,50,77)
    table.attach(self.violinButton,65,77,50,77)
    table.attach(self.label,10,77,0,10)
    table.attach(self.scoreTitle,50,77,11,21)
    table.attach(self.scoreLabel,50,77,22,33)
    table.attach(self.resetButton,5,15,22,32)
    table.attach(self.quitButton,5,15,0,10)
    table.attach(self.helpButton,5,15,11,21)
    #table.attach(self.turnText,20,60,15,35)
    #table.attach(self.turnCount,5,25,0,13)

    #self.guitarButton.show()
    #self.drumButton.show()
    #self.pianoButton.show()
    #self.trumpetButton.show()
    #self.violinButton.show()
    #self.label.show() 
    #self.scoreTitle.show()
    #self.scoreLabel.show()
    #self.turnText.show()
    #self.turnCount.show()
      
    
    self.window.add(table)
    #table.show()
    #self.window.show_all()
    #self.window.grab_focus()        
    #hoobox.pack_start(table2,True,True,0)
    #table2.show()
    #list = [0,1,2,3,4,0,1,2,3,4,0,1,2,3,4,4,3,2,1,0]
    #list = [0,1,2,3,3,0]

    #self.playThread.start()

  def runSequenceThread(self,list):
    self.playThread = threading.Thread(target = self.playSequence, args = (list,))
    self.playThread.start()
    #self.playThread.join()
    #self.playThread.interrupt_main()
    print "do we get here?? before the sound ends?"
    #self.aGame.setThreadDone()
    #self.xxx()
    
  def setGame(self,game):
        self._game = game

  def playClick(self, widget, data):
    self.label.set_text(" ")
    self.playSound(data)
    dataNum = self.parseNumber(data)
    if self.firstRun == 1:
        self.startGame()
        self.aGame.addNote(dataNum)
        return
    if self.gameMode == "single":
      if self.correct_pattern == 1:
          
          self.aGame.addNote(dataNum)
          self.score = self.score + 1
          self.scoreLabel.set_text(str(self.score))
          self.correct_pattern = 0
          return
      if self.aGame.verifyPattern(dataNum) == 1:
        #press next
        return
      elif self.aGame.verifyPattern(dataNum) == 2:
        self.correct_pattern = 1
        self.label.set_text("Add a new note to the sequence ")
        return
      else :
        if self.score < 5 :
          self.label.set_text("You failed to reach next level")
        else :
          self.label.set_text("Game over - but you reached master level")
        
        #quit
        return

  def playSound(self, data):
    #self.initButtonImages("normal", self.width)
    self.soundObject.playInstrument(data)
    if self.visualAid == 1:
        self.setButtonImage(data,"green",self.width)
        self.label.set_text(data)
        
  def parseInstrument(self, instrumentCode):
    i = instrumentCode
    if i == 0:
      return "Guitar"
    elif i == 1:
        return "Drum"
    elif i == 2:
        return "Piano"
    elif i == 3:
        return "Trumpet"
    elif i == 4:
        return "Violin"
    
  def parseNumber(self, instrument):
    i = instrument
    if i == "Guitar":
      return 0
    elif i == "Drum":
        return 1
    elif i == "Piano":
        return 2
    elif i == "Trumpet":
        return 3
    elif i == "Violin":
        return 4       
        
  def playSequence(self, data):
    print data
    for i in data: 
      self.playSound(self.parseInstrument(i))
      #select.select([],[],[],0.5)
      select.select([],[],[],0.5)
            
  def disableButtons(self, true):
    if (true == "False"):
      self.initButtonImages("disabled", self.width)
      self.guitarButton.set_sensitive(False)
      self.drumButton.set_sensitive(False)
      self.pianoButton.set_sensitive(False)
      self.trumpetButton.set_sensitive(False)
      self.violinButton.set_sensitive(False)
    else :
      self.initButtonImages("normal", self.width)
      self.guitarButton.set_sensitive(True)
      self.drumButton.set_sensitive(True)
      self.pianoButton.set_sensitive(True)
      self.trumpetButton.set_sensitive(True)
      self.violinButton.set_sensitive(True)
      
            
  def initButtonImages(self, type, width):
        
    self.guitarButton.set_image(self.imageHandler.getImage("Guitar",type, width))
    self.drumButton.set_image(self.imageHandler.getImage("Drum",type, width))
    self.pianoButton.set_image(self.imageHandler.getImage("Piano",type, width))
    self.trumpetButton.set_image(self.imageHandler.getImage("Trumpet",type, width))
    self.violinButton.set_image(self.imageHandler.getImage("Violin",type, width))
        
  def setButtonImage(self, instrument, type, width):
        
    if instrument == "Guitar":
        self.guitarButton.set_image(self.imageHandler.getImage(instrument,type, width))
    elif instrument == "Drum":
        self.drumButton.set_image(self.imageHandler.getImage(instrument,type, width))
    elif instrument == "Piano":
        self.pianoButton.set_image(self.imageHandler.getImage(instrument,type, width))
    elif instrument == "Trumpet":
        self.trumpetButton.set_image(self.imageHandler.getImage(instrument,type, width))
    elif instrument == "Violin":
        self.violinButton.set_image(self.imageHandler.getImage(instrument,type, width))
  
  def startGame(self):
    #aComm = communication.Comm()
    self.aGame = game.Game(self.gameMode)
    self.aGame.setGui(self)
    #self.aGame.startGame()
    #if ((self.gameMode == "client") or (self.gameMode == "host")):
    #    aComm = communication.Comm()
    #    self.aGame.setComm(aComm)
    self.firstRun = 0
  

  def quit(self, *args):
    print "Goodbye cruel world!"
    gtk.main_quit()
        
  #def start(self):
    #self.run()
    
  def on_reset(self,widget):
      self.reset()
      
  def on_quit(self,widget):
      self.quit()
      
  def on_help(self,widget):
      self.help()
    
  def reset(self):
    self.score = 0
    self.correct_pattern = 0  
    self.visualAid = 0
    self.firstRun = 1
    self.label.set_text("Game reset, ready for new one")
    self.scoreLabel.set_text(str(self.score))
    self.aGame.reset()
    
  def help(self):
    
    self.label.set_text("Sorry!  We will provide help after the codecamp!")
    
       
  def run(self):
    self.gameMode = "single"
    if len(sys.argv) == 1:
        print "syntax: "
        self.quit()
    elif len(sys.argv) == 2:
        if sys.argv[1] == "single":
            print "You selected a single game.. game starting"
            self.gameMode = sys.argv[1]
        elif sys.argv[1] == "host":
            print "You selected to host a game.. waiting for a client"
            self.gameMode = sys.argv[1]
        else :
            self.quit()
    elif len(sys.argv) == 3:
        if sys.argv[1] == "client":
            print "You're reaching for a host in IP " + sys.argv[2]
            self.gameMode = sys.argv[1]
        else : 
            self.quit()    
    print len(sys.argv)
    
    self.initWindow();
    self.window.show_all()



    gtk.gdk.threads_init()
    gtk.main()



##############################################################################
##


if __name__ == "__main__":
    logging.basicConfig(level=logging.DEBUG)  
    app = plusOneApp() 
    app.run()   